Bug 1185710 - gnuradio / volk library problem
Summary: gnuradio / volk library problem
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: gnuradio
Version: 20
Hardware: armv7l
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Jaroslav Škarvada
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-01-26 04:26 UTC by Jussi Eloranta
Modified: 2015-02-04 07:58 UTC (History)
3 users (show)

Fixed In Version: gnuradio-3.7.3-3.fc20
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-02-04 07:58:06 UTC
Type: Bug


Attachments (Terms of Use)

Description Jussi Eloranta 2015-01-26 04:26:58 UTC
Description of problem:

The volk library that comes with gnuradio does not seem to work on armv7l.
For example, gqrx program core dumps after spitting out several of these:

VOLK: Error allocating memory (posix_memalign: 22)

There seems to be a workaround for this given in:
https://gnuradio.org/redmine/issues/692
http://lists.gnu.org/archive/html/discuss-gnuradio/2014-03/msg00419.html

I recompiled gnuradio from source with the suggested patch:

diff --git a/volk/lib/volk_malloc.c b/volk/lib/volk_malloc.c
index b2b77dd..e913ffc 100644
--- a/volk/lib/volk_malloc.c
+++ b/volk/lib/volk_malloc.c
@@ -54,7 +54,8 @@

 // Otherwise, test if we are a POSIX or X/Open system
 // This only has a restriction that alignment be a power of 2.
-#if _POSIX_C_SOURCE >= 200112L || _XOPEN_SOURCE >= 600
+//#if _POSIX_C_SOURCE >= 200112L || _XOPEN_SOURCE >= 600
+#if 0

 void *volk_malloc(size_t size, size_t alignment)
 {

and it seems to work now. So, maybe include this patch form arm for now or it would be even better to fix the code properly.

Version-Release number of selected component (if applicable):

Current FC 20 packages.

How reproducible:

Every time

Steps to Reproduce:
1. Install gnuradio and gqrx
2. Plugin rtl usb dongle (sdr)
3. Start gqrx

Actual results:

Program core dumps.

Expected results:

gqrx should display the waterfall and demodulate the RF signals.


Additional info:

Comment 1 Jaroslav Škarvada 2015-01-26 10:57:53 UTC
Thanks for the report. I think upstream has it wrong in the current code [1].

I am applying the "upstream proposed workaround for now.

[1] https://gnuradio.org/redmine/issues/692#note-14

Comment 2 Jussi Eloranta 2015-01-26 14:15:25 UTC
Forgot - in addition to disabling the posix malloc, I also had to disable neon to get it to compile - just like the above web page mentions.

Comment 3 Jaroslav Škarvada 2015-01-26 15:03:52 UTC
(In reply to Jussi Eloranta from comment #2)
> Forgot - in addition to disabling the posix malloc, I also had to disable
> neon to get it to compile - just like the above web page mentions.

Neon is disabled by default in Fedora, it needs to be build --with=neon to enable.

Comment 4 Fedora Update System 2015-01-26 15:04:22 UTC
gnuradio-3.7.5.1-2.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/gnuradio-3.7.5.1-2.fc21

Comment 5 Fedora Update System 2015-01-26 15:25:51 UTC
gnuradio-3.7.3-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/gnuradio-3.7.3-3.fc20

Comment 6 Fedora Update System 2015-01-27 02:56:28 UTC
Package gnuradio-3.7.3-3.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing gnuradio-3.7.3-3.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-1186/gnuradio-3.7.3-3.fc20
then log in and leave karma (feedback).

Comment 7 Fedora Update System 2015-02-04 07:58:06 UTC
gnuradio-3.7.5.1-2.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2015-02-04 07:58:47 UTC
gnuradio-3.7.3-3.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.